Subject: bug#27581: closed (Re: bug#27581: 26.0.50; Error while compiling new Org code)

From: [email-masked] (GNU bug Tracking System)
Date: Thu, 01 Oct 2020 12:00:03 +0000

Your bug report

#27581: 26.0.50; Error while compiling new Org code

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
27581: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=27581
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#27581: 26.0.50; Error while compiling new Org code
From: Stefan Kangas <[email-masked]>
To: Stefan Monnier <[email-masked]>
Cc: [email-masked], [email-masked]
Date: Thu, 1 Oct 2020 04:59:14 -0700
List-Id: <debbugs-submit.debbugs.gnu.org>

Stefan Kangas <[email-masked]> writes:

> Stefan Monnier <[email-masked]> writes:
>
>>> I think I hit this, and doing 'make autoloads' fixed it.
>>
>> Duh, indeed, so the `declare-function` should be removed.
>> Remains my question about the use of eval-after-load.
>
> Stefan Monnier <[email-masked]> writes:
>
>> So it's triggered during the evaluation of org-compat.el's after-load:
>>
>>     (eval-after-load 'org
>>       '(progn
>>          (org-link-set-parameters "file+emacs") ;since Org 9.0
>>          (org-link-set-parameters "file+sys"))) ;since Org 9.0
>>
>> There's a (declare-function org-element-update-syntax ...) in org.el but
>> it looks like org-element is not loaded in this case.
>>
>> Not sure which is the right fix, but I do wonder why have this
>> eval-after-load in org-compat.el instead of simply moving the code to
>> org.el: eval-after-load is normally only used when we need to add code
>> to a file that's not under our control.
>
> I can't find that eval-after-load in org-compat.el, so I guess this has
> been fixed in the three years since this was reported.
>
> I guess this should be closed then?

More information was requested, but none was given within 7 weeks, so
I'm closing this bug.  If this is still an issue, please reply to this
email (use "Reply to all" in your email client) and we can reopen the
bug report.

Best regards,
Stefan Kangas

Subject: 26.0.50; Error while compiling new Org code
From: Stefan Monnier <[email-masked]>
To: [email-masked]
Date: Tue, 04 Jul 2017 20:58:20 -0400
List-Id: <debbugs-submit.debbugs.gnu.org>

Package: Emacs
Version: 26.0.50

When building Emacs's master branch I get errors like:

      ELC      org/org-archive.elc
    
    In toplevel form:
    org/org-archive.el:31:1:Error: Symbol’s function definition is void: org-element-update-syntax
    Makefile:297 : la recette pour la cible « org/org-archive.elc » a échouée

The corresponding stack trace looks like:

    Debugger entered--Lisp error: (void-function org-element-update-syntax)
      (org-element-update-syntax)
      (if data (setcdr data (org-combine-plists (cdr data) parameters)) (setq org-link-parameters (cons (cons type parameters) org-link-parameters)) (org-make-link-regexps) (org-element-update-syntax))
      (let ((data (assoc type org-link-parameters))) (if data (setcdr data (org-combine-plists (cdr data) parameters)) (setq org-link-parameters (cons (cons type parameters) org-link-parameters)) (org-make-link-regexps) (org-element-update-syntax)))
      org-link-set-parameters("file+emacs")
      (progn (org-link-set-parameters "file+emacs") (org-link-set-parameters "file+sys"))
      (closure (org-table1-hline-regexp org-table-tab-recognizes-table\.el org-table-dataline-regexp org-table-any-border-regexp t) nil (progn (org-link-set-parameters "file+emacs") (org-link-set-parameters "file+sys")))()
      eval-after-load-helper("/home/monnier/src/emacs/trunk/lisp/org/org.el")
      run-hook-with-args(eval-after-load-helper "/home/monnier/src/emacs/trunk/lisp/org/org.el")
      do-after-load-evaluation("/home/monnier/src/emacs/trunk/lisp/org/org.el")
      load-with-code-conversion("/home/monnier/src/emacs/trunk/lisp/org/org.el" "/home/monnier/src/emacs/trunk/lisp/org/org.el" nil t)
      require(org)

So it's triggered during the evaluation of org-compat.el's after-load:

    (eval-after-load 'org
      '(progn
         (org-link-set-parameters "file+emacs") ;since Org 9.0
         (org-link-set-parameters "file+sys"))) ;since Org 9.0

There's a (declare-function org-element-update-syntax ...) in org.el but
it looks like org-element is not loaded in this case.

Not sure which is the right fix, but I do wonder why have this
eval-after-load in org-compat.el instead of simply moving the code to
org.el: eval-after-load is normally only used when we need to add code
to a file that's not under our control.

        Stefan

In GNU Emacs 26.0.50 (build 1, x86_64-unknown-linux-gnu, GTK+ Version 2.24.31)
 of 2017-06-28 built on ceviche
Repository revision: 5ca96e5cef1a562dbafc0b14ce6ef0f3362a7be6
Windowing system distributor 'The X.Org Foundation', version 11.0.11902000
System Description:	Debian GNU/Linux testing (buster)

Recent messages:
Saving file /home/monnier/share/misc/recettes...
Wrote /home/monnier/share/misc/recettes
Saving file /home/monnier/share/misc/recettes...
Wrote /home/monnier/share/misc/recettes
Quit
Mark saved where search started
Appended 9 songs
Appended 12 songs
Set MPD volume to 80%
Set MPD volume to 85%

Configured using:
 'configure -C --enable-checking --with-modules --enable-check-lisp-object-type
 'CFLAGS=-Wall -g3 -Og -Wno-pointer-sign'
 PKG_CONFIG_PATH=/home/monnier/lib/pkgconfig'

Configured features:
XPM JPEG TIFF GIF PNG RSVG SOUND GPM DBUS GCONF GSETTINGS NOTIFY GNUTLS
LIBXML2 FREETYPE M17N_FLT LIBOTF XFT ZLIB TOOLKIT_SCROLL_BARS GTK2 X11
MODULES

Important settings:
  value of $LANG: fr_CH.UTF-8
  locale-coding-system: utf-8-unix

Major mode: InactiveMinibuffer

Minor modes in effect:
  diff-auto-refine-mode: t
  electric-pair-mode: t
  global-reveal-mode: t
  reveal-mode: t
  auto-insert-mode: t
  savehist-mode: t
  minibuffer-electric-default-mode: t
  global-compact-docstrings-mode: t
  url-handler-mode: t
  cl-old-struct-compat-mode: t
  global-eldoc-mode: t
  electric-indent-mode: t
  mouse-wheel-mode: t
  global-prettify-symbols-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  line-number-mode: t
  transient-mark-mode: t

Load-path shadows:
/home/monnier/src/emacs/elpa/packages/svg/svg hides /home/monnier/src/emacs/work/lisp/svg
/home/monnier/src/emacs/elpa/packages/ada-mode/ada-xref hides /home/monnier/src/emacs/work/lisp/progmodes/ada-xref
/home/monnier/src/emacs/elpa/packages/ada-mode/ada-mode hides /home/monnier/src/emacs/work/lisp/progmodes/ada-mode
/home/monnier/src/emacs/elpa/packages/ada-mode/ada-stmt hides /home/monnier/src/emacs/work/lisp/progmodes/ada-stmt
/home/monnier/src/emacs/elpa/packages/ada-mode/ada-prj hides /home/monnier/src/emacs/work/lisp/progmodes/ada-prj
/home/monnier/src/emacs/elpa/packages/hyperbole/set hides /home/monnier/src/emacs/work/lisp/emacs-lisp/set
/home/monnier/src/emacs/elpa/packages/landmark/landmark hides /home/monnier/src/emacs/work/lisp/obsolete/landmark
/home/monnier/src/emacs/elpa/packages/crisp/crisp hides /home/monnier/src/emacs/work/lisp/obsolete/crisp

Features:
(mail-extr emacsbug message subr-x puny dired dired-loaddefs format-spec
rfc822 mml mml-sec gnus-util rmail rmail-loaddefs mm-decode mm-bodies
mm-encode mail-parse rfc2231 mailabbrev mailheader sendmail rfc2047
rfc2045 ietf-drums mm-util mail-prsvr mail-utils sort mpc cl-print
epa-file epa derived epg view cal-china lunar solar cal-dst cal-bahai
cal-islam cal-hebrew holidays hol-loaddefs cal-french diary-lib
diary-loaddefs cal-move cal-menu calendar cal-loaddefs executable
copyright whitespace vc vc-dispatcher misearch multi-isearch xscheme
warnings unsafep trace testcover shadow scheme re-builder profiler
inf-lisp ielm comint ansi-color ring gmm-utils ert pp find-func ewoc
debug elp edebug cl-indent cus-edit cus-start cus-load wid-edit vc-git
diff-mode filecache map server time-date noutline outline easy-mmode
flyspell ispell checkdoc thingatpt help-mode load-dir elec-pair reveal
autoinsert proof-site proof-autoloads cl pg-vars savehist minibuf-eldef
disp-table compact-docstrings kotl-loaddefs advice info
realgud-recursive-autoloads finder-inf url-auth package easymenu
epg-config url-handlers url-parse auth-source eieio eieio-core cl-macs
eieio-loaddefs password-cache url-vars seq byte-opt gv bytecomp
byte-compile cconv cl-loaddefs cl-lib bbdb-autoloads mule-util tooltip
eldoc electric uniquify ediff-hook vc-hooks lisp-float-type mwheel
term/x-win x-win term/common-win x-dnd tool-bar dnd fontset image
regexp-opt fringe tabulated-list replace newcomment text-mode elisp-mode
lisp-mode prog-mode register page menu-bar rfn-eshadow isearch timer
select scroll-bar mouse jit-lock font-lock syntax font-core
term/tty-colors frame cl-generic cham georgian utf-8-lang misc-lang
vietnamese tibetan thai tai-viet lao korean japanese eucjp-ms cp51932
hebrew greek romanian slovak czech european ethiopic indian cyrillic
chinese composite charscript charprop case-table epa-hook jka-cmpr-hook
help simple abbrev obarray minibuffer cl-preloaded nadvice loaddefs
button faces cus-face macroexp files text-properties overlay sha1 md5
base64 format env code-pages mule custom widget hashtable-print-readable
backquote dbusbind inotify dynamic-setting system-font-setting
font-render-setting move-toolbar gtk x-toolkit x multi-tty
make-network-process emacs)

Memory information:
((conses 8 229863 26761)
 (symbols 24 28561 0) (miscs 20 6691 1319) (strings 16 68847 5556)
 (string-bytes 1 2027719)
 (vectors 8 38247) (vector-slots 4 1585708 54106) (floats 8 667 649)
 (intervals 28 8528 944)
 (buffers 520 29))